%define hsc_name ghc
%define hsc_version %ghc_version
%define hsc_namever %hsc_name
%define h_pkg_name hashed-storage
%define f_pkg_name hashed-storage
%define pkg_libdir %{_libdir}/%{hsc_name}-%{hsc_version}/lib/%{h_pkg_name}-%{version}

Name: %{hsc_namever}-%{f_pkg_name}
Version: 0.3.8
Release: alt1
License: BSD3
Group: Development/Haskell
URL: http://hackage.haskell.org/package/hashed-storage
Packager: Alexey Voinov <voins@altlinux.ru>
Source: %f_pkg_name-%version.tar
Summary: Hashed file storage support code

BuildRequires: ghc
BuildRequires: %hs_package_dependencies mtl mmap extensible-exceptions zlib
BuildRequires(pre): rpm-build-haskell


%description
Support code for reading and manipulating hashed file storage (where
each file and directory is associated with a cryptographic hash, for
corruption-resistant storage and fast comparisons).

The supported storage formats include darcs hashed pristine, a plain
filesystem tree and an indexed plain tree (where the index maintains
hashes of the plain files and directories).

%prep
%setup -n %{h_pkg_name}-%{version}

%build
if [ -f configure.ac -a ! -f configure ]; then autoreconf; fi
runghc Setup configure --prefix=%{_prefix} --libdir=%{_libdir} \
    --docdir=%{_docdir}/%{hsc_namever}-%{f_pkg_name}-%{version} \
    --libsubdir='$compiler/lib/$pkgid' --disable-library-profiling --ghc
if runghc Setup makefile -f cabal-rpm.mk
then
    %make_build -f cabal-rpm.mk || :
fi
runghc Setup build
runghc Setup haddock || :
runghc Setup register --gen-pkg-config=%f_pkg_name.pkg


%install
runghc Setup copy --destdir=${RPM_BUILD_ROOT}
install -m 755 %f_pkg_name.pkg %buildroot%pkg_libdir

mkdir -p %buildroot%hs_pkgconfdir
%hs_package_register %f_pkg_name.pkg %buildroot%hs_pkgconfdir/%f_pkg_name.conf

cd ${RPM_BUILD_ROOT}
find .%{pkg_libdir} \( -name '*_p.a' -o -name '*.p_hi' \) | sed s/^.// >> %{_builddir}/%{?buildsubdir}/%{name}-files.prof
find .%{pkg_libdir} -type d | sed 's/^./%dir /' >> %{_builddir}/%{?buildsubdir}/%{name}-files.nonprof
find .%{pkg_libdir} ! \( -type d -o -name '*_p.a' -o -name '*.p_hi' \) | sed s/^.// >> %{_builddir}/%{?buildsubdir}/%{name}-files.nonprof
sed 's,^/,%exclude /,' %{_builddir}/%{?buildsubdir}/%{name}-files.prof >> %{_builddir}/%{?buildsubdir}/%{name}-files.nonprof

cd ${RPM_BUILD_ROOT}/%{_datadir}/doc/%{hsc_namever}-%{f_pkg_name}-%{version}
rm -rf doc LICENSE README


%files  -f %{name}-files.nonprof
%hs_pkgconfdir/%f_pkg_name.conf
%doc dist/doc/html
%doc LICENSE


%changelog
* Mon Oct 05 2009 Alexey Voinov <voins@altlinux.ru> 0.3.8-alt1
- Initial build for Sisyphus.
